Index: /BAORadio/libindi/libindi/indiserver.c
===================================================================
--- /BAORadio/libindi/libindi/indiserver.c	(revision 696)
+++ /BAORadio/libindi/libindi/indiserver.c	(revision 697)
@@ -790,6 +790,9 @@
                 else if (strstr(token, "\"") || strstr(token, "'"))
                 {
-		    strncat(tDev, ++token, sizeof(tDev)-strlen(tDev)-1);
-                    while (token = strsep(&cp, delm) )
+                    strncat(tDev, ++token, sizeof(tDev)-strlen(tDev)-1);
+
+                    if ( tDev[strlen(tDev)-2] == '\"' || tDev[strlen(tDev)-2] == '\'')
+                        tDev[strlen(tDev)-2] = '\0';
+                   else while (token = strsep(&cp, delm) )
                    {
                      strcat(tDev, " ");
@@ -797,5 +800,5 @@
                      if ( (tp=strchr(tDev, '\"')) || (tp=strchr(tDev, '\'')))
                      {
-                         //tDev[strlen(tDev)-1] = '\0';
+                         tDev[strlen(tDev)-1] = '\0';
                          *tp='\0';
                          break;
@@ -818,4 +821,8 @@
                       {
                        strncat(tConfig, ++token, sizeof(tConfig)-strlen(tDev)-1);
+
+                       if ( tConfig[strlen(tConfig)-2] == '\"' || tConfig[strlen(tConfig)-2] == '\'')
+                           tConfig[strlen(tConfig)-2] = '\0';
+
                        while (token = strsep(&cp, delm) )
                        {
@@ -825,5 +832,5 @@
                           if ( (tp=strchr(tConfig, '\"')) || (tp=strchr(tConfig, '\'')))
                           {
-                                 //tConfig[strlen(tConfig)-1] = '\0';
+                               tConfig[strlen(tConfig)-1] = '\0';
                               *tp = '\0';
                               break;
Index: /BAORadio/libindi/libindi/libindi.pro
===================================================================
--- /BAORadio/libindi/libindi/libindi.pro	(revision 696)
+++ /BAORadio/libindi/libindi/libindi.pro	(revision 697)
@@ -4,4 +4,5 @@
 
 TEMPLATE = app
+CONFIG += debug
 TARGET = 
 DEPENDPATH += . \
@@ -39,5 +40,4 @@
 # Input
 HEADERS += base64.h \
-           config.h \
            eventloop.h \
            fq.h \
@@ -163,12 +163,12 @@
            communs/ServerSocket.cpp \
            communs/Socket.cpp \
-           examples/tutorial_ccdpreview.c \
-           examples/tutorial_client.cpp \
-           examples/tutorial_dome.c \
-           examples/tutorial_four.cpp \
-           examples/tutorial_one.c \
-           examples/tutorial_rain.c \
-           examples/tutorial_three.c \
-           examples/tutorial_two.c \
+#           examples/tutorial_ccdpreview.c \
+#           examples/tutorial_client.cpp \
+#           examples/tutorial_dome.c \
+#           examples/tutorial_four.cpp \
+#           examples/tutorial_one.c \
+#           examples/tutorial_rain.c \
+#           examples/tutorial_three.c \
+#           examples/tutorial_two.c \
            libs/indicom.c \
            libs/lilxml.c \
@@ -179,12 +179,12 @@
            drivers/ccd/ccd_simulator.cpp \
            drivers/ccd/fli_ccd.c \
-           drivers/filter_wheel/filter_simulator.cpp \
-           drivers/filter_wheel/fli_wheel.c \
-           drivers/filter_wheel/trutech_wheel.c \
-           drivers/focuser/fli_pdf.c \
-           drivers/focuser/robofocus.c \
-           drivers/focuser/robofocus.cpp \
-           drivers/focuser/robofocusdriver.c \
-           drivers/focuser/tcfs.cpp \
+#           drivers/filter_wheel/filter_simulator.cpp \
+#           drivers/filter_wheel/fli_wheel.c \
+#           drivers/filter_wheel/trutech_wheel.c \
+#           drivers/focuser/fli_pdf.c \
+#           drivers/focuser/robofocus.c \
+#           drivers/focuser/robofocus.cpp \
+#           drivers/focuser/robofocusdriver.c \
+#           drivers/focuser/tcfs.cpp \
            drivers/telescope/BAO.cpp \
            drivers/telescope/celestrongps.cpp \
@@ -210,11 +210,11 @@
            drivers/telescope/telescope_simulator.cpp \
            drivers/telescope/temmadriver.c \
-           drivers/video/indi_lpi.cpp \
-           drivers/video/indi_philips.cpp \
-           drivers/video/indi_v4l.cpp \
-           drivers/video/stv.c \
-           drivers/video/stvdriver.c \
-           drivers/video/v4ldriver.cpp \
-           drivers/video/v4lphilips.cpp \
+#           drivers/video/indi_lpi.cpp \
+#           drivers/video/indi_philips.cpp \
+#           drivers/video/indi_v4l.cpp \
+#           drivers/video/stv.c \
+#           drivers/video/stvdriver.c \
+#           drivers/video/v4ldriver.cpp \
+#           drivers/video/v4lphilips.cpp \
            Indi_Stellarium/src/Connection.cpp \
            Indi_Stellarium/src/Listener.cpp \
@@ -235,11 +235,11 @@
            libs/indibase/inditelescope.cpp \
            libs/indibase/indiusbdevice.cpp \
-           libs/webcam/ccvt_c2.c \
-           libs/webcam/ccvt_misc.c \
-           libs/webcam/port.cpp \
-           libs/webcam/PPort.cpp \
-           libs/webcam/v4l1_base.cpp \
-           libs/webcam/v4l1_pwc.cpp \
-           libs/webcam/v4l2_base.cpp \
+#           libs/webcam/ccvt_c2.c \
+#           libs/webcam/ccvt_misc.c \
+#           libs/webcam/port.cpp \
+#           libs/webcam/PPort.cpp \
+#           libs/webcam/v4l1_base.cpp \
+#           libs/webcam/v4l1_pwc.cpp \
+#           libs/webcam/v4l2_base.cpp \
            libindi_build/CMakeFiles/CompilerIdC/CMakeCCompilerId.c \
            libindi_build/CMakeFiles/CompilerIdCXX/CMakeCXXCompilerId.cpp
Index: /BAORadio/libindi/libindi/libs/indibase/baseclient.cpp
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/baseclient.cpp	(revision 696)
+++ /BAORadio/libindi/libindi/libs/indibase/baseclient.cpp	(revision 697)
@@ -25,7 +25,8 @@
 #include <netinet/in.h>
 #include <netdb.h>
+#include <fcntl.h>
 
 #include "baseclient.h"
-#include "basedriver.h"
+#include "basedevice.h"
 #include "indicom.h"
 
@@ -46,5 +47,5 @@
 INDI::BaseClient::~BaseClient()
 {
-    close(sockfd);
+
 }
 
@@ -65,4 +66,5 @@
     struct sockaddr_in serv_addr;
     struct hostent *hp;
+    int sflags=0;
 
     /* lookup host address */
@@ -85,4 +87,8 @@
     }
 
+//    sflags=fcntl(sockfd,F_GETFL,0);         // Get socket flags
+//    fcntl(sockfd,F_SETFL, sflags | O_NONBLOCK);   // Add non-blocking flag
+
+
     /* connect */
     if (::connect (sockfd,(struct sockaddr *)&serv_addr,sizeof(serv_addr))<0)
@@ -95,4 +101,10 @@
     svrwfp = fdopen (sockfd, "w");
 
+    if (svrwfp == NULL)
+    {
+        perror("fdopen");
+        return false;
+    }
+
     int result = pthread_create( &listen_thread, NULL, &INDI::BaseClient::listenHelper, this);
 
@@ -103,6 +115,6 @@
     }
 
+    sConnected = true;
     serverConnected();
-    sConnected = true;
 
     return true;
@@ -111,6 +123,12 @@
 bool INDI::BaseClient::disconnectServer()
 {
+   // IDLog("Server disconnected called\n");
     if (sConnected == false)
         return true;
+
+    sConnected = false;
+
+    //IDLog("Closing socket fd!\n");
+    close(sockfd);
 
     if (svrwfp != NULL)
@@ -118,11 +136,18 @@
    svrwfp = NULL;
 
-   close(sockfd);
-
-    serverDisconnected();
-
-    sConnected = false;
-
-    return true;
+   pthread_join(listen_thread, NULL);
+
+   return true;
+}
+
+
+void INDI::BaseClient::connectDevice(const char *deviceName)
+{
+    setDriverConnection(true, deviceName);
+}
+
+void INDI::BaseClient::disconnectDevice(const char *deviceName)
+{
+        setDriverConnection(false, deviceName);
 }
 
@@ -130,5 +155,5 @@
 void INDI::BaseClient::setDriverConnection(bool status, const char *deviceName)
 {
-    INDI::BaseDriver *drv = getDriver(deviceName);
+    INDI::BaseDevice *drv = getDevice(deviceName);
     ISwitchVectorProperty *drv_connection = NULL;
 
@@ -156,5 +181,5 @@
         drv_connection->sp[1].s = ISS_OFF;
 
-        sendNewSwitch(drv_connection, &(drv_connection->sp[0]));
+        sendNewSwitch(drv_connection);
     }
     else
@@ -169,15 +194,15 @@
         drv_connection->sp[1].s = ISS_ON;
 
-        sendNewSwitch(drv_connection, &(drv_connection->sp[1]));
-
-    }
-}
-
-
-INDI::BaseDriver * INDI::BaseClient::getDriver(const char * deviceName)
-{
-    vector<INDI::BaseDriver *>::const_iterator devi;
+        sendNewSwitch(drv_connection);
+
+    }
+}
+
+
+INDI::BaseDevice * INDI::BaseClient::getDevice(const char * deviceName)
+{
+    vector<INDI::BaseDevice *>::const_iterator devi;
     for ( devi = cDevices.begin(); devi != cDevices.end(); devi++)
-        if (!strcmp(deviceName, (*devi)->deviceName()))
+        if (!strcmp(deviceName, (*devi)->getDeviceName()))
             return (*devi);
 
@@ -193,7 +218,15 @@
 void INDI::BaseClient::listenINDI()
 {
+    char buffer[MAXINDIBUF];
     char msg[MAXRBUF];
-    char buffer[MAXINDIBUF];
+
     int n=0, err_code=0;
+    struct timeval tv;
+    fd_set rs;
+    FD_ZERO(&rs);
+
+    tv.tv_sec  = 1;
+    tv.tv_usec = 0;//500000;
+
 
     if (cDeviceNames.empty())
@@ -208,22 +241,42 @@
     fflush (svrwfp);
 
+    FD_SET(sockfd, &rs);
+
     lillp = newLilXML();
+
 
     /* read from server, exit if find all requested properties */
     while (sConnected)
     {
-        n = read(sockfd, buffer, MAXINDIBUF);
-
-        if (n ==0)
+        n = select (sockfd+1, &rs, NULL, NULL, &tv);
+
+        if (n < 0)
         {
-            perror ("read");
-            fprintf (stderr,"INDI server %s/%d disconnected\n", cServer.c_str(), cPort);
-            serverDisconnected();
-            return;
+            fprintf (stderr,"INDI server %s/%d disconnected.\n", cServer.c_str(), cPort);
+            close(sockfd);
+            break;
         }
+
+        n = recv(sockfd, buffer, MAXINDIBUF, MSG_DONTWAIT);
+        if (n<=0)
+        {
+
+            if (n==0)
+            {
+                fprintf (stderr,"INDI server %s/%d disconnected.\n", cServer.c_str(), cPort);
+                close(sockfd);
+                break;
+            }
+            else
+                continue;
+        }
+
 
         for (int i=0; i < n; i++)
         {
+            //IDLog("Getting #%d bytes in for loop, calling readXMLEle for byte %d\n", n, i);
             XMLEle *root = readXMLEle (lillp, buffer[i], msg);
+            //IDLog("############# BLOCK # POST READ XML ELE #####################\n");
+
             if (root)
             {
@@ -233,5 +286,5 @@
                      if (err_code != INDI_PROPERTY_DUPLICATED)
                      {
-                         IDLog("Dispatch command error: %s\n", msg);
+                         IDLog("Dispatch command error(%d): %s\n", err_code, msg);
                          prXMLEle (stderr, root, 0);
                      }
@@ -248,4 +301,13 @@
     }
 
+    //IDLog("Termindating Listen therad!\n");
+    delLilXML(lillp);
+
+    //IDLog("sConnected value at termination is: %s\n", (sConnected ? "True" : "False"));
+    serverDisconnected( (sConnected == false) ? 0 : -1);
+    sConnected = false;
+
+    pthread_exit(0);
+
 }
 
@@ -258,5 +320,5 @@
 
     /* Get the device, if not available, create it */
-    INDI::BaseDriver *dp = findDev (root, 1, errmsg);
+    INDI::BaseDevice *dp = findDev (root, 1, errmsg);
     if (dp == NULL)
     {
@@ -264,4 +326,10 @@
         return INDI_DEVICE_NOT_FOUND;
     }
+
+    // FIXME REMOVE THIS
+
+    // Ignore echoed newXXX
+    if (strstr(tagXMLEle(root), "new"))
+        return 0;
 
     if ((!strcmp (tagXMLEle(root), "defTextVector"))  ||
@@ -289,5 +357,5 @@
 {
     XMLAtt *ap;
-    INDI::BaseDriver *dp;
+    INDI::BaseDevice *dp;
 
     /* dig out device and optional property name */
@@ -296,5 +364,5 @@
         return INDI_DEVICE_NOT_FOUND;
 
-    checkMsg(root, dp);
+    dp->checkMessage(root);
 
     ap = findXMLAtt (root, "name");
@@ -302,17 +370,24 @@
     /* Delete property if it exists, otherwise, delete the whole device */
     if (ap)
-        return dp->removeProperty(valuXMLAtt(ap));
+    {
+        INDI::Property *rProp = dp->getProperty(valuXMLAtt(ap));
+        removeProperty(rProp);
+        int errCode = dp->removeProperty(valuXMLAtt(ap), errmsg);
+
+        return errCode;
+    }
     // delete the whole device
     else
-        return removeDevice(dp->deviceName(), errmsg);
+        return removeDevice(dp->getDeviceName(), errmsg);
 }
 
 int INDI::BaseClient::removeDevice( const char * devName, char * errmsg )
 {
-    std::vector<INDI::BaseDriver *>::iterator devicei;
+    std::vector<INDI::BaseDevice *>::iterator devicei;
 
     for (devicei =cDevices.begin(); devicei != cDevices.end();)
     {
-      if (strcmp(devName, (*devicei)->deviceName()))
+
+      if (!strcmp(devName, (*devicei)->getDeviceName()))
       {
           delete *devicei;
@@ -328,12 +403,12 @@
 }
 
-INDI::BaseDriver * INDI::BaseClient::findDev( const char * devName, char * errmsg )
-{
-
-    std::vector<INDI::BaseDriver *>::const_iterator devicei;
+INDI::BaseDevice * INDI::BaseClient::findDev( const char * devName, char * errmsg )
+{
+
+    std::vector<INDI::BaseDevice *>::const_iterator devicei;
 
     for (devicei = cDevices.begin(); devicei != cDevices.end(); devicei++)
     {
-        if (!strcmp(devName, (*devicei)->deviceName()))
+        if (!strcmp(devName, (*devicei)->getDeviceName()))
          return (*devicei);
 
@@ -345,8 +420,8 @@
 
 /* add new device */
-INDI::BaseDriver * INDI::BaseClient::addDevice (XMLEle *dep, char * errmsg)
+INDI::BaseDevice * INDI::BaseClient::addDevice (XMLEle *dep, char * errmsg)
 {
     //devicePtr dp(new INDI::BaseDriver());
-    INDI::BaseDriver *dp = new INDI::BaseDriver();
+    INDI::BaseDevice *dp = new INDI::BaseDevice();
     XMLAtt *ap;
     char * device_name;
@@ -367,5 +442,5 @@
     cDevices.push_back(dp);
 
-    newDevice(device_name);
+    newDevice(dp);
 
     /* ok */
@@ -373,8 +448,8 @@
 }
 
-INDI::BaseDriver * INDI::BaseClient::findDev (XMLEle *root, int create, char * errmsg)
+INDI::BaseDevice * INDI::BaseClient::findDev (XMLEle *root, int create, char * errmsg)
 {
     XMLAtt *ap;
-    INDI::BaseDriver *dp;
+    INDI::BaseDevice *dp;
     char *dn;
 
@@ -407,49 +482,12 @@
 int INDI::BaseClient::messageCmd (XMLEle *root, char * errmsg)
 {
-    checkMsg (root, findDev (root, 0, errmsg));
+    INDI::BaseDevice *dp =findDev (root, 0, errmsg);
+
+    if (dp)
+        dp->checkMessage(root);
+
     return (0);
 }
 
-/* add message to queue
- * N.B. don't put carriage control in msg, we take care of that.
- */
-void INDI::BaseClient::checkMsg (XMLEle *root, INDI::BaseDriver *dp)
-{
-    XMLAtt *ap;
-    ap = findXMLAtt(root, "message");
-
-    if (ap)
-        doMsg(root, dp);
-}
-
-/* Store msg in queue */
-void INDI::BaseClient::doMsg (XMLEle *msg, INDI::BaseDriver *dp)
-{
-    XMLAtt *message;
-    XMLAtt *time_stamp;
-    char msgBuffer[MAXRBUF];
-
-    if (dp == NULL)
-        return;
-
-    /* prefix our timestamp if not with msg */
-    time_stamp = findXMLAtt (msg, "timestamp");
-
-    if (time_stamp)
-        snprintf(msgBuffer, MAXRBUF, "%s ", valuXMLAtt(time_stamp));
-    else
-        snprintf(msgBuffer, MAXRBUF, "%s ", timestamp());
-
-    /* finally! the msg */
-    message = findXMLAtt(msg, "message");
-
-    if (!message) return;
-
-    // Prepend to the log
-   dp->addMessage(msgBuffer);
-   dp->addMessage(valuXMLAtt(message));
-   dp->addMessage("\n");
-\
-}
 
 void INDI::BaseClient::sendNewText (ITextVectorProperty *tvp)
@@ -471,4 +509,28 @@
 }
 
+void INDI::BaseClient::sendNewText (const char * deviceName, const char * propertyName, const char* elementName, const char *text)
+{
+
+    INDI::BaseDevice *drv = getDevice(deviceName);
+
+    if (drv == NULL)
+        return;
+
+    ITextVectorProperty *tvp = drv->getText(propertyName);
+
+    if (tvp == NULL)
+        return;
+
+    IText * tp = IUFindText(tvp, elementName);
+
+    if (tp == NULL)
+        return;
+
+    tvp->s = IPS_BUSY;
+    IUSaveText(tp, text);
+
+    sendNewText(tvp);
+}
+
 void INDI::BaseClient::sendNewNumber (INumberVectorProperty *nvp)
 {
@@ -489,18 +551,83 @@
 }
 
-void INDI::BaseClient::sendNewSwitch (ISwitchVectorProperty *svp, ISwitch *sp)
-{
+void INDI::BaseClient::sendNewNumber (const char *deviceName, const char *propertyName, const char* elementName, double value)
+{
+    INDI::BaseDevice *drv = getDevice(deviceName);
+
+    if (drv == NULL)
+        return;
+
+    INumberVectorProperty *nvp = drv->getNumber(propertyName);
+
+    if (nvp == NULL)
+        return;
+
+    INumber * np = IUFindNumber(nvp, elementName);
+
+    if (np == NULL)
+        return;
+
+    np->value = value;
+    nvp->s = IPS_BUSY;
+
+    sendNewNumber(nvp);
+
+}
+
+void INDI::BaseClient::sendNewSwitch (ISwitchVectorProperty *svp)
+{
+    ISwitch *onSwitch = IUFindOnSwitch(svp);
+
     fprintf(svrwfp, "<newSwitchVector\n");
 
     fprintf(svrwfp, "  device='%s'\n", svp->device);
     fprintf(svrwfp, "  name='%s'>\n", svp->name);
-    fprintf(svrwfp, "  <oneSwitch\n");
-    fprintf(svrwfp, "    name='%s'>\n", sp->name);
-    fprintf(svrwfp, "      %s\n", (sp->s == ISS_ON) ? "On" : "Off");
-    fprintf(svrwfp, "  </oneSwitch>\n");
+
+    if (svp->r == ISR_1OFMANY && onSwitch)
+    {
+        fprintf(svrwfp, "  <oneSwitch\n");
+        fprintf(svrwfp, "    name='%s'>\n", onSwitch->name);
+        fprintf(svrwfp, "      %s\n", (onSwitch->s == ISS_ON) ? "On" : "Off");
+        fprintf(svrwfp, "  </oneSwitch>\n");
+    }
+    else
+    {
+        for (int i=0; i < svp->nsp; i++)
+        {
+            fprintf(svrwfp, "  <oneSwitch\n");
+            fprintf(svrwfp, "    name='%s'>\n", svp->sp[i].name);
+            fprintf(svrwfp, "      %s\n", (svp->sp[i].s == ISS_ON) ? "On" : "Off");
+            fprintf(svrwfp, "  </oneSwitch>\n");
+
+        }
+    }
 
     fprintf(svrwfp, "</newSwitchVector>\n");
 
     fflush(svrwfp);
+}
+
+void INDI::BaseClient::sendNewSwitch (const char *deviceName, const char *propertyName, const char *elementName)
+{
+    INDI::BaseDevice *drv = getDevice(deviceName);
+
+    if (drv == NULL)
+        return;
+
+    ISwitchVectorProperty *svp = drv->getSwitch(propertyName);
+
+    if (svp == NULL)
+        return;
+
+    ISwitch * sp = IUFindSwitch(svp, elementName);
+
+    if (sp == NULL)
+        return;
+
+    sp->s = ISS_ON;
+    svp->s = IPS_BUSY;
+
+    sendNewSwitch(svp);
+
 }
 
@@ -513,5 +640,5 @@
 }
 
-void INDI::BaseClient::sendOneBlob( const char *blobName, unsigned int blobSize, const char *blobFormat, unsigned char * blobBuffer)
+void INDI::BaseClient::sendOneBlob( const char *blobName, unsigned int blobSize, const char *blobFormat, void * blobBuffer)
 {
     fprintf(svrwfp, "  <oneBLOB\n");
@@ -521,5 +648,5 @@
 
     for (unsigned i = 0; i < blobSize; i += 72)
-        fprintf(svrwfp, "    %.72s\n", blobBuffer+i);
+        fprintf(svrwfp, "    %.72s\n", ((char *) blobBuffer+i));
 
     fprintf(svrwfp, "   </oneBLOB>\n");
Index: /BAORadio/libindi/libindi/libs/indibase/baseclient.h
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/baseclient.h	(revision 696)
+++ /BAORadio/libindi/libindi/libs/indibase/baseclient.h	(revision 697)
@@ -38,5 +38,5 @@
    BaseClient enables accelerated development of INDI Clients by providing a framework that facilitates communication, device
    handling, and event notification. By subclassing BaseClient, clients can quickly connect to an INDI server, and query for
-   a set of INDI::BaseDriver devices, and read and write properties seamlessly. Event driven programming is possible due to
+   a set of INDI::BaseDevice devices, and read and write properties seamlessly. Event driven programming is possible due to
    notifications upon reception of new devices or properties.
 
@@ -52,5 +52,5 @@
 public:
     enum { INDI_DEVICE_NOT_FOUND=-1, INDI_PROPERTY_INVALID=-2, INDI_PROPERTY_DUPLICATED = -3, INDI_DISPATCH_ERROR=-4 };
-    //typedef boost::shared_ptr<INDI::BaseDriver> devicePtr;
+    //typedef boost::shared_ptr<INDI::BaseDevice> devicePtr;
 
     BaseClient();
@@ -67,5 +67,5 @@
         A client may select to receive notifications of only a specific device or a set of devices.
         If the client encounters any of the devices set via this function, it will create a corresponding
-        INDI::BaseDriver object to handle them. If no devices are watched, then all devices owned by INDI server
+        INDI::BaseDevice object to handle them. If no devices are watched, then all devices owned by INDI server
         will be created and handled.
     */
@@ -87,19 +87,22 @@
     bool disconnectServer();
 
-    /** \brief Connect/Disconnect to INDI driver
-        \param status If true, the client will attempt to turn on CONNECTION property within the driver (i.e. turn on the device).
-         Otherwise, CONNECTION will be turned off.
+    /** \brief Connect to INDI driver
         \param deviceName Name of the device to connect to.
     */
-    void setDriverConnection(bool status, const char *deviceName);
+    void connectDevice(const char *deviceName);
+
+    /** \brief Disconnect INDI driver
+        \param deviceName Name of the device to disconnect.
+    */
+    void disconnectDevice(const char *deviceName);
 
     /** \param deviceName Name of device to search for in the list of devices owned by INDI server,
          \returns If \e deviceName exists, it returns an instance of the device. Otherwise, it returns NULL.
     */
-    INDI::BaseDriver * getDriver(const char * deviceName);
+    INDI::BaseDevice * getDevice(const char * deviceName);
 
     /** \returns Returns a vector of all devices created in the client.
     */
-    const vector<INDI::BaseDriver *> & getDrivers() const { return cDevices; }
+    const vector<INDI::BaseDevice *> & getDevices() const { return cDevices; }
 
     /** \brief Set Binary Large Object policy mode
@@ -125,43 +128,57 @@
     static void * listenHelper(void *context);
 
-protected:
-
-    /** \brief Dispatch command received from INDI server to respective devices handled by the client */
-    int dispatchCommand(XMLEle *root, char* errmsg);
-
-    /** \brief Remove device */
-    int removeDevice( const char * devName, char * errmsg );
-
-    /** \brief Delete property command */
-    int delPropertyCmd (XMLEle *root, char * errmsg);
-
-    /** \brief Find and return a particular device */
-    INDI::BaseDriver * findDev( const char * devName, char * errmsg);
-    /** \brief Add a new device */
-    INDI::BaseDriver * addDevice (XMLEle *dep, char * errmsg);
-    /** \brief Find a device, and if it doesn't exist, create it if create is set to 1 */
-    INDI::BaseDriver * findDev (XMLEle *root, int create, char * errmsg);
-
-    /**  Process messages */
-    int messageCmd (XMLEle *root, char * errmsg);
-    /**  Process messages */
-    void checkMsg (XMLEle *root, INDI::BaseDriver *dp);
-    /**  Process messages */
-    void doMsg (XMLEle *msg, INDI::BaseDriver *dp);
+    const char * getHost() { return cServer.c_str();}
+    int getPort() { return cPort; }
 
     /** \brief Send new Text command to server */
     void sendNewText (ITextVectorProperty *pp);
+    /** \brief Send new Text command to server */
+    void sendNewText (const char * deviceName, const char * propertyName, const char* elementName, const char *text);
     /** \brief Send new Number command to server */
     void sendNewNumber (INumberVectorProperty *pp);
+    /** \brief Send new Number command to server */
+    void sendNewNumber (const char * deviceName, const char *propertyName, const char* elementName, double value);
     /** \brief Send new Switch command to server */
-    void sendNewSwitch (ISwitchVectorProperty *pp, ISwitch *lp);
+    void sendNewSwitch (ISwitchVectorProperty *pp);
+    /** \brief Send new Switch command to server */
+    void sendNewSwitch (const char * deviceName, const char *propertyName, const char *elementName);
+
     /** \brief Send opening tag for BLOB command to server */
     void startBlob( const char *devName, const char *propName, const char *timestamp);
     /** \brief Send ONE blob content to server */
-    void sendOneBlob( const char *blobName, unsigned int blobSize, const char *blobFormat, unsigned char * blobBuffer);
+    void sendOneBlob( const char *blobName, unsigned int blobSize, const char *blobFormat, void * blobBuffer);
     /** \brief Send closing tag for BLOB command to server */
     void finishBlob();
 
+protected:
+
+    /** \brief Dispatch command received from INDI server to respective devices handled by the client */
+    int dispatchCommand(XMLEle *root, char* errmsg);
+
+    /** \brief Remove device */
+    int removeDevice( const char * devName, char * errmsg );
+
+    /** \brief Delete property command */
+    int delPropertyCmd (XMLEle *root, char * errmsg);
+
+    /** \brief Find and return a particular device */
+    INDI::BaseDevice * findDev( const char * devName, char * errmsg);
+    /** \brief Add a new device */
+    INDI::BaseDevice * addDevice (XMLEle *dep, char * errmsg);
+    /** \brief Find a device, and if it doesn't exist, create it if create is set to 1 */
+    INDI::BaseDevice * findDev (XMLEle *root, int create, char * errmsg);
+
+    /**  Process messages */
+    int messageCmd (XMLEle *root, char * errmsg);
+
+
 private:
+
+    /** \brief Connect/Disconnect to INDI driver
+        \param status If true, the client will attempt to turn on CONNECTION property within the driver (i.e. turn on the device).
+         Otherwise, CONNECTION will be turned off.
+        \param deviceName Name of the device to connect to.
+    */
+    void setDriverConnection(bool status, const char *deviceName);
 
     // Listen to INDI server and process incoming messages
@@ -171,5 +188,5 @@
     pthread_t listen_thread;
 
-    vector<INDI::BaseDriver *> cDevices;
+    vector<INDI::BaseDevice *> cDevices;
     vector<string> cDeviceNames;
 
Index: /BAORadio/libindi/libindi/libs/indibase/indibase.h
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/indibase.h	(revision 696)
+++ /BAORadio/libindi/libindi/libs/indibase/indibase.h	(revision 697)
@@ -33,6 +33,6 @@
     class BaseMediator;
     class BaseClient;
-    class BaseDriver;
-    class DefaultDriver;
+    class BaseDevice;
+    class DefaultDevice;
     class FilterInterface;
     class GuiderInterface;
@@ -41,6 +41,18 @@
     class FilterWheel;
     class Focuser;
-    class USBDevice;   
+    class USBDevice;
+    class Property;
 }
+
+/*! INDI property type */
+typedef enum
+{
+    INDI_NUMBER, /*!< INumberVectorProperty. */
+    INDI_SWITCH, /*!< ISwitchVectorProperty. */
+    INDI_TEXT,   /*!< ITextVectorProperty. */
+    INDI_LIGHT,  /*!< ILightVectorProperty. */
+    INDI_BLOB,    /*!< IBLOBVectorProperty. */
+    INDI_UNKNOWN
+} INDI_TYPE;
 
 
@@ -56,11 +68,19 @@
         \param device_name Name of the new device
     */
-    virtual void newDevice(const char *device_name)  =0;
+    virtual void newDevice(INDI::BaseDevice *dp)  =0;
 
     /** \brief Emmited when a new property is created for an INDI driver.
-        \param device_name Name of the device
-        \param property_name Name of the new property
+        \param property Pointer to the Property Container
+
     */
-    virtual void newProperty(const char *device_name, const char *property_name)  =0;
+    virtual void newProperty(INDI::Property *property)  =0;
+
+
+    /** \brief Emmited when a property is deleted for an INDI driver.
+        \param property Pointer to the Property Container to remove.
+
+    */
+    virtual void removeProperty(INDI::Property *property)  =0;
+
 
     /** \brief Emmited when a new BLOB value arrives from INDI server.
@@ -89,4 +109,9 @@
     virtual void newLight(ILightVectorProperty *lvp) =0;
 
+    /** \brief Emmited when a new message arrives from INDI server.
+        \param dp pointer to the INDI device the message is sent to.
+    */
+    virtual void newMessage(INDI::BaseDevice *dp) =0;
+
     /** \brief Emmited when the server is connected.
     */
@@ -94,6 +119,7 @@
 
     /** \brief Emmited when the server gets disconnected.
+        \param exit_code 0 if client was requested to disconnect from server. -1 if connection to server is terminated due to remote server disconnection.
     */
-    virtual void serverDisconnected() =0;
+    virtual void serverDisconnected(int exit_code) =0;
 };
 
